unit hiMatrixStr;

interface

uses Windows,Kol,Share,Debug;

type
  THIMatrixStr = class(TArray)
   private
    HFld, Cols, Rows :TXArray;
    Obj: TMatrix;
    UseNameA: Byte;
    procedure _FSet(var Item:TData; var Val:TData);
    function _FGet(Var Item:TData; var Val:TData):boolean;
    procedure _FAdd(var Val:TData);
    procedure _CSet(var Item:TData; var Val:TData);
    function _CGet(Var Item:TData; var Val:TData):boolean;
    procedure _CAdd(var Val:TData);
    procedure _RSet(var Item:TData; var Val:TData);
    function _RGet(var Item:TData; var Val:TData):boolean;
    procedure _RAdd(var Val:TData);
    procedure _DelRow(item:TData);
    procedure _DelCol(item:TData);

    procedure _Set(col,row:integer; var Val:TData);
    function _Get(col,row:integer):TData;
    function _Rows:Integer;
    function _in(col, row: integer):boolean;
    function _GetColNumb(col: TData):Integer;
    procedure _Expand(col,row:integer);

   private
    function DataToPointer(var Data:TData):cardinal; override;
    procedure PointerToData(Data:cardinal; var Result:TData); override;
    procedure Delete(Value:cardinal); override;
    procedure Save(P:pointer; Data:cardinal); override;
    procedure Load(P:pointer; var Data:cardinal); override;
    //function Swap(d1,d2:cardinal):boolean; override;
    procedure SetUseName(val: Byte);
   public
    _prop_AutoSize:boolean;
    _prop_StrDelimiter:string;
    _event_onChange:THI_Event;

    constructor Create;
    procedure _var_Matrix(var _Data:TData; Index:word);
    procedure _var_Fields(var _Data:TData; Index:word);
    procedure _var_RowsArr(var _Data:TData; Index:word);
    procedure _var_ColsArr(var _Data:TData; Index:word);
    procedure _var_Cols(var _Data:TData; Index:word);
    procedure _var_Rows(var _Data:TData; Index:word);
    procedure _work_doLoadA(var _Data:TData; Index:word);
    property _prop_UseNameA:Byte write SetUseName;
    property _prop_MatrixStr:PStrListEx write SetItems;
  end;

function MakeArrayStrList(Names:PChar; Values:array of pchar):PStrListEx;

implementation

function MakeArrayStrList;
var i:integer;
    r:PStrList;
begin
   Result := NewStrListEx;
   Result.Text := Names;
   for i := 0 to Result.Count-1 do
    begin
     r:=NewStrList;
     r.Text:=Values[i];
     Result.Objects[i] := cardinal(r);
    end;
end;

constructor THIMatrixStr.Create;
begin
   inherited Create;
   Obj._Set := _Set;
   Obj._Get := _Get;
   Obj._Rows := _Rows;
   Obj._Cols := Count;

   HFld._Set := _FSet;
   HFld._Get := _FGet;
   HFld._Count := Count;
   HFld._Add := _FAdd;

   Rows._Set := _RSet;
   Rows._Get := _RGet;
   Rows._Count := _Rows;
   Rows._Add := _RAdd;

   Cols._Set := _CSet;
   Cols._Get := _CGet;
   Cols._Count := Count;
   Cols._Add := _CAdd;
end;

procedure THIMatrixStr._work_doLoadA(var _Data:TData; Index:word);
var fn:string;
begin
   fn := ReadString(_data,_data_FileName,_prop_FileName);
   if FileExists(fn) then begin
     _work_doLoad(_Data,Index);
     _hi_OnEvent(_event_onChange);
   end;
end;

procedure THIMatrixStr.SetUseName;
begin
  UseNameA:=Val;
  _prop_UseName:=false;
  if val=1 then _prop_UseName:=true;
end;

// ####################### Rows #################################
procedure THIMatrixStr._RSet;
var c,i:integer;
    r:PStrList;
    dt: TData;
begin
   if val.data_type=data_null then begin _DelRow(item); exit; end;
   c:=ToIntIndex(Item);
   dt.data_type:=data_str;
   if (c >= 0) then Begin
     r:=NewStrList;
     r.Text := ToString(Val);
     For i:=0 to r.count-1 do begin
       dt.sdata:=r.items[i];
       _set(i,c,dt);
     End;
     r.free;
     _hi_OnEvent(_event_onChange);
   end;
end;

procedure THIMatrixStr._RAdd;
var dt: TData;
    a: boolean;
begin
  a:=_prop_AutoSize; _prop_AutoSize:=True;
  dt:=_DoData(_Rows);
  _RSet(dt,val);
  _prop_AutoSize:=a;
end;

function THIMatrixStr._RGet;
 var i,c:integer;
begin
   c:=ToIntIndex(Item);
   Result := false;
   if (c < 0) and (c >= _rows) then exit;
   Result := true;
   Val.data_type := data_str;
   val.sdata:=ToString(_get(0,c));
   For i:=1 to Count-1 do
      val.sdata:=val.sdata+_prop_StrDelimiter+ToString(_get(i, c));
end;

procedure THIMatrixStr._DelRow;
var c,i,mr:integer;
    PS:PStrList;
begin
   c:=ToIntIndex(Item);
   if (c <0 ) or (c >= _rows) or (Count<1) then exit;
   for i:=0 to Count-1 do begin
     PS:=PStrList(items.Objects[i]);
     if C<PS.Count then PS.Delete(C);
   end;
   _hi_OnEvent(_event_onChange);
end;

// ####################### Columns #################################
function THIMatrixStr._CGet(Var Item:TData; var Val:TData):boolean;
begin
  If UseNameA=2 Then _prop_UseName:=(item.data_type=data_str);
  If Read(item,val) and (_prop_StrDelimiter<>#13#10) then begin
    replace(val.sdata,#13#10,_prop_StrDelimiter);
    val.sdata:=copy(val.sdata,1,length(val.sdata)-length(_prop_StrDelimiter));
  end;
  //msgbox(item.sdata+':'+val.sdata,1);
end;

procedure THIMatrixStr._CSet;
var c:integer;
begin
   if val.data_type=data_null then begin _DelCol(item); exit; end;
   c:=_getColNumb(Item);
   _Expand(c,-1);
   if (c >= 0) and (c < Count) then Begin
      PStrList(items.Objects[c]).text := ToString(Val);
      _hi_OnEvent(_event_onChange);
   end;
end;

procedure THIMatrixStr._CAdd;
begin
   add(val);
   _hi_OnEvent(_event_onChange);
end;

// ####################### Fields #################################
procedure THIMatrixStr._FSet;
var c:integer;
begin
   if val.data_type=data_null then begin _DelCol(item); exit; end;
   c:=_getColNumb(Item);
   _Expand(c,-1);
   if (c >= 0) and (c < Count) then begin
    Items.Items[c] := ToString(Val);
     _hi_OnEvent(_event_onChange);
   end;
end;

procedure THIMatrixStr._FAdd;
begin
  items.AddObject(ToString(val), cardinal(NewStrList));
  _hi_OnEvent(_event_onChange);
end;

function THIMatrixStr._FGet;
var i:integer;
begin
   Result := false;
   i := _getColNumb(Item);
   if (i < 0) or (i >= Count) then exit;
   Result := true;
   Val.data_type := data_str;
   Val.sdata := Items.Items[i];
end;

procedure THIMatrixStr._DelCol;
var c:integer;
begin
   c:=_getColNumb(item);
   if (c <0 ) or (c >= items.count) then exit;
   Delete(items.Objects[c]);
   items.delete(c);
   _hi_OnEvent(_event_onChange);
end;

// ####################### TArray ##################################
function THIMatrixStr.DataToPointer;
var r:PStrList;
begin
   r:=NewStrList;
   r.Text:=ToString(Data);
   Result := cardinal(r);
end;

procedure THIMatrixStr.PointerToData;
begin
   Result.Data_type := data_str;
   Result.sdata := PStrList(Data).Text;
end;

procedure THIMatrixStr.Save;
begin
   PStream(p).writeStrEx(PStrList(Data).Text);
end;

procedure THIMatrixStr.Load;
var SL:PStrList;
begin
  SL := NewStrList;
  if _prop_FileFormat = 0 then SL.Text:=PStream(p).ReadStrEx;
  Data := integer(SL);
end;

procedure THIMatrixStr.Delete;
begin
   PStrList(Value).Free;
end;

// ####################### Matrix ##################################
function THIMatrixStr._rows; //  
Var i: integer;
begin
  result:=0;
  if items.count>0 then
   For i:=0 to items.count-1 do
     if PStrList(items.Objects[i]).count>result Then
       result:=PStrList(items.Objects[i]).count;
end;

procedure THIMatrixStr._Set;
begin
   _Expand(Col,Row);
   if _in(col,row) Then
      PStrList(items.Objects[col]).Items[row] := ToString(Val);
end;

function THIMatrixStr._Get;
begin
   Result.Data_type := data_null;
   if not _in(col,row) then exit;
   Result.Data_type := data_str;
   Result.sdata := PStrList(items.Objects[col]).Items[Row];
end;

procedure THIMatrixStr._Expand;
Var PS: PStrList;
begin
   if (not _prop_AutoSize) or (col<1) then exit;
   While Count<=col do items.AddObject(int2str(Count), cardinal(NewStrList));
   PS:=PStrList(items.Objects[col]);
   While PS.Count<=row do PS.Add('');
end;

function THIMatrixStr._in;
begin
  result:=false;
  if (col >=0 ) and (col < items.count) then
    if (row >=0) and (row < PStrList(items.Objects[col]).Count) then result:=true;
end;

function THIMatrixStr._GetColNumb(col: TData):Integer;
var i: Integer;
    CName: String;
begin
  result:=-1;
  If UseNameA=2 Then _prop_UseName:=(col.data_type=data_str);
  If _prop_UseName and (items.Count>0) Then
    Begin
      cName:=ToString(Col);
      for i := 0 to Items.Count-1 do
        if Items.Items[i] = cName then begin Result:=i; exit; end;
    end
  else result:=ToIntIndex(Col);
end;

//################### VARS ############################
procedure THIMatrixStr._var_Matrix;
begin
   _Data.Data_type := data_matr;
   _Data.idata := integer(@Obj);
end;

procedure THIMatrixStr._var_Fields;
begin
   _Data.Data_type := data_array;
   _Data.idata := integer(@HFld);
end;

procedure THIMatrixStr._var_ColsArr;
begin
   _Data.Data_type := data_array;
   _Data.idata := integer(@Cols);
end;

procedure THIMatrixStr._var_RowsArr;
begin
   _Data.Data_type := data_array;
   _Data.idata := integer(@Rows);
end;

procedure THIMatrixStr._var_Cols;
begin
  _Data.Data_type := data_int;
  _Data.idata:=Count;
end;

procedure THIMatrixStr._var_Rows;
begin
  _Data.Data_type := data_int;
  _Data.idata:=_Rows;
end;

end.
